--- old/usr/src/cmd/awk/run.c	2013-05-11 15:20:45.824142601 +0000
+++ new/usr/src/cmd/awk/run.c	2013-05-11 15:20:45.848298484 +0000
@@ -766,179 +852,222 @@
 	y = execute(a[1]);
 	s2 = getsval(y);
 
-	z = gettemp("");
+	z = gettemp();
 	for (p1 = s1; *p1 != '\0'; p1++) {
 		for (q = p1, p2 = s2; *p2 != '\0' && *q == *p2; q++, p2++)
 			;
 		if (*p2 == '\0') {
-			v = (Awkfloat) (p1 - s1 + 1);	/* origin 1 */
+			v = (Awkfloat)(p1 - s1 + 1);	/* origin 1 */
 			break;
 		}
 	}
-	tempfree(x, "");
-	tempfree(y, "");
+	tempfree(x);
+	tempfree(y);
 	(void) setfval(z, v);
 	return (z);
 }
 
-void
-format(uchar **bufp, uchar *s, Node *a)
+#define	MAXNUMSIZE	50
+
+/*
+ * printf-like conversions
+ */
+int
+format(uchar **bufp, size_t *pbufsize, const uchar *s, Node *a)
 {
 	uchar *fmt;
-	register uchar *os;
-	register Cell *x;
-	int flag = 0, len;
-	uchar_t	*buf;
-	size_t bufsize, fmtsize, cnt, tcnt, ret;
+	uchar *p, *t;
+	const uchar *os;
+	Cell *x;
+	int flag = 0, n;
+	int fmtwd; /* format width */
+	size_t fmtsz = record_size;
+	uchar_t	*buf = *bufp;
+	size_t bufsize = *pbufsize;
 
-	init_buf(&buf, &bufsize, LINE_INCR);
-	init_buf(&fmt, &fmtsize, LINE_INCR);
 	os = s;
-	cnt = 0;
+	p = buf;
+	if ((fmt = (uchar *)malloc(fmtsz)) == NULL)
+		FATAL("out of memory in format()");
 	while (*s) {
+		(void) adjbuf(&buf, &bufsize, MAXNUMSIZE + 1 + p - buf,
+		    record_size, &p, "format1");
 		if (*s != '%') {
-			expand_buf(&buf, &bufsize, cnt);
-			buf[cnt++] = *s++;
+			*p++ = *s++;
 			continue;
 		}
 		if (*(s+1) == '%') {
-			expand_buf(&buf, &bufsize, cnt);
-			buf[cnt++] = '%';
+			*p++ = '%';
 			s += 2;
 			continue;
 		}
-		for (tcnt = 0; ; s++) {
-			expand_buf(&fmt, &fmtsize, tcnt);
-			fmt[tcnt++] = *s;
-			if (*s == '\0')
-				break;
-			if (isalpha(*s) && *s != 'l' && *s != 'h' && *s != 'L')
-				break;	/* the ansi panoply */
+		/*
+		 * have to be real careful in case this is a huge number,
+		 * eg, %100000d
+		 */
+		fmtwd = atoi((char *)s + 1);
+		if (fmtwd < 0)
+			fmtwd = -fmtwd;
+		(void) adjbuf(&buf, &bufsize, fmtwd + 1 + p - buf,
+		    record_size, &p, "format2");
+		for (t = fmt; (*t++ = *s) != '\0'; s++) {
+			if (!adjbuf(&fmt, &fmtsz, MAXNUMSIZE + 1 + t - fmt,
+			    record_size, &t, "format3"))
+				FATAL(
+			"format item %.30s... ran format() out of memory", os);
+			if (isalpha((uchar)*s) && *s != 'l' && *s != 'h' &&
+			    *s != 'L')
+				break;  /* the ansi panoply */
 			if (*s == '*') {
-				if (a == NULL) {
-					ERROR
-		"not enough args in printf(%s) or sprintf(%s)", os, os FATAL;
-				}
 				x = execute(a);
 				a = a->nnext;
-				tcnt--;
-				expand_buf(&fmt, &fmtsize, tcnt + 12);
-				ret = sprintf((char *)&fmt[tcnt], "%d",
-				    (int)getfval(x));
-				tcnt += ret;
-				tempfree(x, "");
+				(void) sprintf((char *)t - 1, "%d",
+				    fmtwd = (int)getfval(x));
+				if (fmtwd < 0)
+					fmtwd = -fmtwd;
+				(void) adjbuf(&buf, &bufsize, fmtwd + 1 + p -
+				    buf, record_size, &p, "format");
+				t = fmt + strlen((char *)fmt);
+				tempfree(x);
 			}
 		}
-		fmt[tcnt] = '\0';
+		*t = '\0';
+		if (fmtwd < 0)
+			fmtwd = -fmtwd;
+		(void) adjbuf(&buf, &bufsize, fmtwd + 1 + p - buf,
+		    record_size, &p, "format4");
 
 		switch (*s) {
 		case 'f': case 'e': case 'g': case 'E': case 'G':
-			flag = 1;
+			flag = 'f';
 			break;
 		case 'd': case 'i':
-			flag = 2;
+			flag = 'd';
 			if (*(s-1) == 'l')
 				break;
-			fmt[tcnt - 1] = 'l';
-			expand_buf(&fmt, &fmtsize, tcnt);
-			fmt[tcnt++] = 'd';
-			fmt[tcnt] = '\0';
+			*(t-1) = 'l';
+			*t = 'd';
+			*++t = '\0';
 			break;
 		case 'o': case 'x': case 'X': case 'u':
-			flag = *(s-1) == 'l' ? 2 : 3;
+			flag = *(s-1) == 'l' ? 'd' : 'u';
 			break;
 		case 's':
-			flag = 4;
+			flag = 's';
 			break;
 		case 'c':
-			flag = 5;
+			flag = 'c';
 			break;
 		default:
-			flag = 0;
+			WARNING("weird printf conversion %s", fmt);
+			flag = '?';
 			break;
 		}
-		if (flag == 0) {
-			len = strlen((char *)fmt);
-			expand_buf(&buf, &bufsize, cnt + len);
-			(void) memcpy(&buf[cnt], fmt, len);
-			cnt += len;
-			buf[cnt] = '\0';
-			continue;
-		}
 		if (a == NULL) {
-			ERROR
-	"not enough args in printf(%s) or sprintf(%s)", os, os FATAL;
+			FATAL(
+	"not enough args in printf(%s)", os);
 		}
 		x = execute(a);
 		a = a->nnext;
-		for (;;) {
-			/* make sure we have at least 1 byte space */
-			expand_buf(&buf, &bufsize, cnt + 1);
-			len = bufsize - cnt;
-			switch (flag) {
-			case 1:
-				/*LINTED*/
-				ret = snprintf((char *)&buf[cnt], len,
-				    (char *)fmt, getfval(x));
-				break;
-			case 2:
-				/*LINTED*/
-				ret = snprintf((char *)&buf[cnt], len,
-				    (char *)fmt, (long)getfval(x));
-				break;
-			case 3:
-				/*LINTED*/
-				ret = snprintf((char *)&buf[cnt], len,
-				    (char *)fmt, (int)getfval(x));
-				break;
-			case 4:
-				/*LINTED*/
-				ret = snprintf((char *)&buf[cnt], len,
-				    (char *)fmt, getsval(x));
-				break;
-			case 5:
-				if (isnum(x)) {
-					/*LINTED*/
-					ret = snprintf((char *)&buf[cnt], len,
-					    (char *)fmt, (int)getfval(x));
-				} else {
-					/*LINTED*/
-					ret = snprintf((char *)&buf[cnt], len,
-					    (char *)fmt, getsval(x)[0]);
+		n = MAXNUMSIZE;
+		if (fmtwd > n)
+			n = fmtwd;
+		(void) adjbuf(&buf, &bufsize, 1 + n + p - buf, record_size,
+		    &p, "format5");
+
+		switch (flag) {
+		case '?':
+			/* unknown, so dump it too */
+			/* LINTED E_SEC_SPRINTF_UNBOUNDED_COPY */
+			(void) sprintf((char *)p, "%s", (char *)fmt);
+			t = getsval(x);
+			n = strlen((char *)t);
+			if (fmtwd > n)
+				n = fmtwd;
+			(void) adjbuf(&buf, &bufsize, 1 + strlen((char *)p) +
+			    n + p - buf, record_size, &p, "format6");
+			p += strlen((char *)p);
+			/* LINTED E_SEC_SPRINTF_UNBOUNDED_COPY */
+			(void) sprintf((char *)p, "%s", t);
+			break;
+		case 'f':
+			/* LINTED E_SEC_PRINTF_VAR_FMT */
+			(void) sprintf((char *)p, (char *)fmt, getfval(x));
+			break;
+		case 'd':
+			/* LINTED E_SEC_PRINTF_VAR_FMT */
+			(void) sprintf((char *)p, (char *)fmt,
+			    (long) getfval(x));
+			break;
+		case 'u':
+			/* LINTED E_SEC_PRINTF_VAR_FMT */
+			(void) sprintf((char *)p, (char *)fmt,
+			    (int) getfval(x));
+			break;
+		case 's':
+			t = getsval(x);
+			n = strlen((char *)t);
+			if (fmtwd > n)
+				n = fmtwd;
+			if (!adjbuf(&buf, &bufsize, 1+n+p-buf, record_size,
+			    &p, "format7"))
+				FATAL(
+		"huge string/format (%d chars) in printf %.30s... "
+		"ran format() out of memory", n, t);
+			/* LINTED E_SEC_PRINTF_VAR_FMT */
+			(void) sprintf((char *)p, (char *)fmt, t);
+			break;
+		case 'c':
+			if (isnum(x)) {
+				if (getfval(x))
+					/* LINTED E_SEC_PRINTF_VAR_FMT */
+					(void) sprintf((char *)p, (char *)fmt,
+					    (int) getfval(x));
+				else {
+					*p++ = '\0'; /* explicit null byte */
+					/* next output will start here */
+					*p = '\0';
 				}
-				break;
-			default:
-				ret = 0;
+			} else {
+				/* LINTED E_SEC_PRINTF_VAR_FMT */
+				(void) sprintf((char *)p, (char *)fmt,
+				    getsval(x)[0]);
 			}
-			if (ret < len)
-				break;
-			expand_buf(&buf, &bufsize, cnt + ret);
+			break;
+		default:
+			FATAL("can't happen: bad conversion %c in format()",
+			    flag);
 		}
-		tempfree(x, "");
-		cnt += ret;
+		tempfree(x);
+		p += strlen((char *)p);
 		s++;
 	}
-	buf[cnt] = '\0';
+	*p = '\0';
+	free(fmt);
 	for (; a; a = a->nnext)	/* evaluate any remaining args */
 		(void) execute(a);
-	*bufp = tostring(buf);
-	free(buf);
-	free(fmt);
+	*bufp = buf;
+	*pbufsize = bufsize;
+	return (p - buf);
 }
 
 /*ARGSUSED*/
 Cell *
-a_sprintf(Node **a, int n)
+awksprintf(Node **a, int n)	/* sprintf(a[0]) */
 {
-	register Cell *x;
-	register Node *y;
+	Cell *x;
+	Node *y;
 	uchar *buf;
+	size_t bufsz = 3 * record_size;
 
+	if ((buf = (uchar *)malloc(bufsz)) == NULL)
+		FATAL("out of memory in awksprintf");
 	y = a[0]->nnext;
 	x = execute(a[0]);
-	format(&buf, getsval(x), y);
-	tempfree(x, "");
-	x = gettemp("");
+	if (format(&buf, &bufsz, getsval(x), y) == -1)
+		FATAL("sprintf string %.30s... too long.  can't happen.", buf);
+	tempfree(x);
+	x = gettemp();
 	x->sval = buf;
 	x->tval = STR;
 	return (x);
@@ -946,44 +1075,56 @@
 
 /*ARGSUSED*/
 Cell *
-aprintf(Node **a, int n)
-{
+awkprintf(Node **a, int n)	/* printf */
+{	/* a[0] is list of args, starting with format string */
+	/* a[1] is redirection operator, a[2] is redirection file */
 	FILE *fp;
-	register Cell *x;
-	register Node *y;
+	Cell *x;
+	Node *y;
 	uchar *buf;
+	int len;
+	size_t bufsz = 3 * record_size;
 
+	if ((buf = (uchar *)malloc(bufsz)) == NULL)
+		FATAL("out of memory in awkprintf");
 	y = a[0]->nnext;
 	x = execute(a[0]);
-	format(&buf, getsval(x), y);
-	tempfree(x, "");
-	if (a[1] == NULL)
-		(void) fputs((char *)buf, stdout);
-	else {
-		fp = redirect((int)a[1], a[2]);
-		(void) fputs((char *)buf, fp);
+	if ((len = format(&buf, &bufsz, getsval(x), y)) == -1)
+		FATAL("printf string %.30s... too long.  can't happen.", buf);
+	tempfree(x);
+	if (a[1] == NULL) {
+		/* fputs(buf, stdout); */
+		(void) fwrite((char *)buf, len, 1, stdout);
+		if (ferror(stdout))
+			FATAL("write error on stdout");
+	} else {
+		fp = redirect(ptoi(a[1]), a[2]);
+		/* fputs(buf, fp); */
+		(void) fwrite(buf, len, 1, fp);
 		(void) fflush(fp);
+		if (ferror(fp))
+			FATAL("write error on %s", filename(fp));
 	}
 	free(buf);
-	return (true);
+	return (True);
 }
 
 Cell *
-arith(Node **a, int n)
+arith(Node **a, int n)	/* a[0] + a[1], etc.  also -a[0] */
 {
-	Awkfloat i, j;
+	Awkfloat i, j = 0;
 	double v;
-	register Cell *x, *y, *z;
+	Cell *x, *y, *z;
 
 	x = execute(a[0]);
 	i = getfval(x);
-	tempfree(x, "");
+	tempfree(x);
 	if (n != UMINUS) {
 		y = execute(a[1]);
 		j = getfval(y);
-		tempfree(y, "");
+		tempfree(y);
 	}
-	z = gettemp("");
+	z = gettemp();
 	switch (n) {
 	case ADD:
 		i += j;
@@ -996,12 +1137,12 @@
 		break;
 	case DIVIDE:
 		if (j == 0)
-			ERROR "division by zero" FATAL;
+			FATAL("division by zero");
 		i /= j;
 		break;
 	case MOD:
 		if (j == 0)
-			ERROR "division by zero in mod" FATAL;
+			FATAL("division by zero in mod");
 		(void) modf(i/j, &v);
 		i = i - j * v;
 		break;
@@ -1015,20 +1156,20 @@
 			i = errcheck(pow(i, j), "pow");
 		break;
 	default:	/* can't happen */
-		ERROR "illegal arithmetic operator %d", n FATAL;
+		FATAL("illegal arithmetic operator %d", n);
 	}
 	(void) setfval(z, i);
 	return (z);
 }
 
 static double
-ipow(double x, int n)
+ipow(double x, int n)	/* x**n.  ought to be done by pow, but isn't always */
 {
 	double v;
 
 	if (n <= 0)
 		return (1.0);
-	v = ipow(x, n/2);
+	v = ipow(x, n / 2);
 	if (n % 2 == 0)
 		return (v * v);
 	else
@@ -1036,10 +1177,10 @@
 }
 
 Cell *
-incrdecr(Node **a, int n)
+incrdecr(Node **a, int n)	/* a[0]++, etc. */
 {
-	register Cell *x, *z;
-	register int k;
+	Cell *x, *z;
+	int k;
 	Awkfloat xf;
 
 	x = execute(a[0]);
@@ -1049,34 +1190,39 @@
 		(void) setfval(x, xf + k);
 		return (x);
 	}
-	z = gettemp("");
+	z = gettemp();
 	(void) setfval(z, xf);
 	(void) setfval(x, xf + k);
-	tempfree(x, "");
+	tempfree(x);
 	return (z);
 }
 
 Cell *
-assign(Node **a, int n)
-{
-	register Cell *x, *y;
+assign(Node **a, int n)	/* a[0] = a[1], a[0] += a[1], etc. */
+{			/* this is subtle; don't muck with it. */
+	Cell *x, *y;
 	Awkfloat xf, yf;
 	double v;
 
 	y = execute(a[1]);
-	x = execute(a[0]);	/* order reversed from before... */
+	x = execute(a[0]);
 	if (n == ASSIGN) {	/* ordinary assignment */
-		if ((y->tval & (STR|NUM)) == (STR|NUM)) {
+		/* self-assignment: */
+		/* LINTED E_NOP_IF_STMT */
+		if (x == y && !(x->tval & (FLD|REC)))
+			/* leave alone unless it's a field */
+			;
+		else if ((y->tval & (STR|NUM)) == (STR|NUM)) {
 			(void) setsval(x, getsval(y));
 			x->fval = getfval(y);
 			x->tval |= NUM;
-		} else if (y->tval & STR)
+		} else if (isstr(y))
 			(void) setsval(x, getsval(y));
-		else if (y->tval & NUM)
+		else if (isnum(y))
 			(void) setfval(x, getfval(y));
 		else
 			funnyvar(y, "read value of");
-		tempfree(y, "");
+		tempfree(y);
 		return (x);
 	}
 	xf = getfval(x);
@@ -1093,12 +1239,12 @@
 		break;
 	case DIVEQ:
 		if (yf == 0)
-			ERROR "division by zero in /=" FATAL;
+			FATAL("division by zero in /=");
 		xf /= yf;
 		break;
 	case MODEQ:
 		if (yf == 0)
-			ERROR "division by zero in %%=" FATAL;
+			FATAL("division by zero in %%=");
 		(void) modf(xf/yf, &v);
 		xf = xf - yf * v;
 		break;
@@ -1109,21 +1255,21 @@
 			xf = errcheck(pow(xf, yf), "pow");
 		break;
 	default:
-		ERROR "illegal assignment operator %d", n FATAL;
+		FATAL("illegal assignment operator %d", n);
 		break;
 	}
-	tempfree(y, "");
+	tempfree(y);
 	(void) setfval(x, xf);
 	return (x);
 }
 
 /*ARGSUSED*/
 Cell *
-cat(Node **a, int q)
+cat(Node **a, int q)		/* a[0] cat a[1] */
 {
-	register Cell *x, *y, *z;
-	register int n1, n2;
-	register uchar *s;
+	Cell *x, *y, *z;
+	int n1, n2;
+	uchar *s;
 
 	x = execute(a[0]);
 	y = execute(a[1]);
@@ -1133,31 +1279,31 @@
 	n2 = strlen((char *)y->sval);
 	s = (uchar *)malloc(n1 + n2 + 1);
 	if (s == NULL) {
-		ERROR "out of space concatenating %.15s and %.15s",
-		    x->sval, y->sval FATAL;
+		FATAL("out of space concatenating %.15s... and %.15s...",
+		    x->sval, y->sval);
 	}
 	(void) strcpy((char *)s, (char *)x->sval);
 	(void) strcpy((char *)s + n1, (char *)y->sval);
-	tempfree(y, "");
-	z = gettemp("");
+	tempfree(x);
+	tempfree(y);
+	z = gettemp();
 	z->sval = s;
 	z->tval = STR;
-	tempfree(x, "");
 	return (z);
 }
 
 /*ARGSUSED*/
 Cell *
-pastat(Node **a, int n)
+pastat(Node **a, int n)		/* a[0] { a[1] } */
 {
-	register Cell *x;
+	Cell *x;
 
 	if (a[0] == 0)
 		x = execute(a[1]);
 	else {
 		x = execute(a[0]);
 		if (istrue(x)) {
-			tempfree(x, "");
+			tempfree(x);
 			x = execute(a[1]);
 		}
 	}
@@ -1166,60 +1312,51 @@
 
 /*ARGSUSED*/
 Cell *
-dopa2(Node **a, int n)
+dopa2(Node **a, int n)		/* a[0], a[1] { a[2] } */
 {
-	Cell	*x;
-	int	pair;
-	static int	*pairstack = NULL;
-
-	if (!pairstack) {
-		/* first time */
-		dprintf(("paircnt: %d\n", paircnt));
-		pairstack = (int *)malloc(sizeof (int) * paircnt);
-		if (!pairstack)
-			ERROR "out of space in dopa2" FATAL;
-		(void) memset(pairstack, 0, sizeof (int) * paircnt);
-	}
+	Cell *x;
+	int pair;
 
-	pair = (int)a[3];
+	pair = ptoi(a[3]);
 	if (pairstack[pair] == 0) {
 		x = execute(a[0]);
 		if (istrue(x))
 			pairstack[pair] = 1;
-		tempfree(x, "");
+		tempfree(x);
 	}
 	if (pairstack[pair] == 1) {
 		x = execute(a[1]);
 		if (istrue(x))
 			pairstack[pair] = 0;
-		tempfree(x, "");
+		tempfree(x);
 		x = execute(a[2]);
 		return (x);
 	}
-	return (false);
+	return (False);
 }
 
 /*ARGSUSED*/
 Cell *
-split(Node **a, int nnn)
+split(Node **a, int nnn)	/* split(a[0], a[1], a[2]); a[3] is type */
 {
-	Cell *x, *y, *ap;
-	register uchar *s;
-	register int sep;
-	uchar *t, temp, num[11], *fs;
-	int n, tempstat;
+	Cell *x = 0, *y, *ap;
+	uchar *s, *origs;
+	int sep;
+	uchar *t, temp, num[50], *fs = 0;
+	int n, tempstat, arg3type;
 
 	y = execute(a[0]);	/* source string */
-	s = getsval(y);
+	origs = s = (uchar *)strdup((char *)getsval(y));
+	arg3type = ptoi(a[3]);
 	if (a[2] == 0)		/* fs string */
 		fs = *FS;
-	else if ((int)a[3] == STRING) {	/* split(str,arr,"string") */
+	else if (arg3type == STRING) {	/* split(str,arr,"string") */
 		x = execute(a[2]);
 		fs = getsval(x);
-	} else if ((int)a[3] == REGEXPR)
+	} else if (arg3type == REGEXPR)
 		fs = (uchar *)"(regexpr)";	/* split(str,arr,/regexpr/) */
 	else
-		ERROR "illegal type of split()" FATAL;
+		FATAL("illegal type of split");
 	sep = *fs;
 	ap = execute(a[1]);	/* array name */
 	freesymtab(ap);
@@ -1229,10 +1366,15 @@
 	ap->sval = (uchar *)makesymtab(NSYMTAB);
 
 	n = 0;
-	if (*s != '\0' && strlen((char *)fs) > 1 || (int)a[3] == REGEXPR) {
+	if (arg3type == REGEXPR && strlen((char *)((fa *)a[2])->restr) == 0) {
+		arg3type = 0;
+		fs = (uchar *)"";
+		sep = 0;
+	}
+	if (*s != '\0' && (strlen((char *)fs) > 1 || arg3type == REGEXPR)) {
 		/* reg expr */
 		fa *pfa;
-		if ((int)a[3] == REGEXPR) {	/* it's ready already */
+		if (arg3type == REGEXPR) {	/* it's ready already */
 			pfa = (fa *)a[2];
 		} else {
 			pfa = makedfa(fs, 1);
@@ -1267,6 +1409,9 @@
 					goto spdone;
 				}
 			} while (nematch(pfa, s));
+			/* bwk: has to be here to reset */
+			pfa->initstat = tempstat;
+			/* cf gsub and refldbld */
 		}
 		n++;
 		(void) sprintf((char *)num, "%d", n);
@@ -1309,6 +1454,23 @@
 			if (*s != 0)
 				s++;
 		}
+	} else if (sep == 0) {	/* new: split(s, a, "") => 1 char/elem */
+		for (n = 0; *s != 0; s++) {
+			uchar buf[2];
+			n++;
+			(void) sprintf((char *)num, "%d", n);
+			buf[0] = *s;
+			buf[1] = 0;
+			if (isdigit(buf[0])) {
+				(void) setsymtab(num, buf, atof((char *)buf),
+				    /* LINTED align */
+				    STR | NUM, (Array *)ap->sval);
+			} else {
+				(void) setsymtab(num, buf, 0.0,
+				    /* LINTED align */
+				    STR, (Array *)ap->sval);
+			}
+		}
 	} else if (*s != 0) {
 		for (;;) {
 			n++;
@@ -1332,11 +1494,13 @@
 				break;
 		}
 	}
-	tempfree(ap, "");
-	tempfree(y, "");
-	if (a[2] != 0 && (int)a[3] == STRING)
-		tempfree(x, "");
-	x = gettemp("");
+	tempfree(ap);
+	tempfree(y);
+	free(origs);
+	if (a[2] != 0 && arg3type == STRING) {
+		tempfree(x);
+	}
+	x = gettemp();
 	x->tval = NUM;
 	x->fval = n;
 	return (x);
@@ -1344,16 +1508,16 @@
 
 /*ARGSUSED*/
 Cell *
-condexpr(Node **a, int n)
+condexpr(Node **a, int n)	/* a[0] ? a[1] : a[2] */
 {
-	register Cell *x;
+	Cell *x;
 
 	x = execute(a[0]);
 	if (istrue(x)) {
-		tempfree(x, "");
+		tempfree(x);
 		x = execute(a[1]);
 	} else {
-		tempfree(x, "");
+		tempfree(x);
 		x = execute(a[2]);
 	}
 	return (x);
@@ -1361,16 +1525,16 @@
 
 /*ARGSUSED*/
 Cell *
-ifstat(Node **a, int n)
+ifstat(Node **a, int n)		/* if (a[0]) a[1]; else a[2] */
 {
-	register Cell *x;
+	Cell *x;
 
 	x = execute(a[0]);
 	if (istrue(x)) {
-		tempfree(x, "");
+		tempfree(x);
 		x = execute(a[1]);
 	} else if (a[2] != 0) {
-		tempfree(x, "");
+		tempfree(x);
 		x = execute(a[2]);
 	}
 	return (x);
@@ -1378,123 +1542,136 @@
 
 /*ARGSUSED*/
 Cell *
-whilestat(Node **a, int n)
+whilestat(Node **a, int n)	/* while (a[0]) a[1] */
 {
-	register Cell *x;
+	Cell *x;
 
 	for (;;) {
 		x = execute(a[0]);
 		if (!istrue(x))
 			return (x);
-		tempfree(x, "");
+		tempfree(x);
 		x = execute(a[1]);
 		if (isbreak(x)) {
-			x = true;
+			x = True;
 			return (x);
 		}
 		if (isnext(x) || isexit(x) || isret(x))
 			return (x);
-		tempfree(x, "");
+		tempfree(x);
 	}
 }
 
 /*ARGSUSED*/
 Cell *
-dostat(Node **a, int n)
+dostat(Node **a, int n)		/* do a[0]; while(a[1]) */
 {
-	register Cell *x;
+	Cell *x;
 
 	for (;;) {
 		x = execute(a[0]);
 		if (isbreak(x))
-			return (true);
+			return (True);
 		if (isnext(x) || isexit(x) || isret(x))
 			return (x);
-		tempfree(x, "");
+		tempfree(x);
 		x = execute(a[1]);
 		if (!istrue(x))
 			return (x);
-		tempfree(x, "");
+		tempfree(x);
 	}
 }
 
 /*ARGSUSED*/
 Cell *
-forstat(Node **a, int n)
+forstat(Node **a, int n)	/* for (a[0]; a[1]; a[2]) a[3] */
 {
-	register Cell *x;
+	Cell *x;
 
 	x = execute(a[0]);
-	tempfree(x, "");
+	tempfree(x);
 	for (;;) {
 		if (a[1] != 0) {
 			x = execute(a[1]);
 			if (!istrue(x))
 				return (x);
 			else
-				tempfree(x, "");
+				tempfree(x);
 		}
 		x = execute(a[3]);
 		if (isbreak(x))		/* turn off break */
-			return (true);
+			return (True);
 		if (isnext(x) || isexit(x) || isret(x))
 			return (x);
-		tempfree(x, "");
+		tempfree(x);
 		x = execute(a[2]);
-		tempfree(x, "");
+		tempfree(x);
 	}
 }
 
 /*ARGSUSED*/
 Cell *
-instat(Node **a, int n)
+instat(Node **a, int n)	/* for (a[0] in a[1]) a[2] */
 {
-	register Cell *x, *vp, *arrayp, *cp, *ncp;
+	Cell *x, *vp, *arrayp, *cp, *ncp;
 	Array *tp;
 	int i;
 
 	vp = execute(a[0]);
 	arrayp = execute(a[1]);
-	if (!isarr(arrayp))
-		ERROR "%s is not an array", arrayp->nval FATAL;
+	if (!isarr(arrayp)) {
+		return (True);
+	}
 	/*LINTED align*/
 	tp = (Array *)arrayp->sval;
-	tempfree(arrayp, "");
+	tempfree(arrayp);
 	for (i = 0; i < tp->size; i++) { /* this routine knows too much */
 		for (cp = tp->tab[i]; cp != NULL; cp = ncp) {
 			(void) setsval(vp, cp->nval);
 			ncp = cp->cnext;
 			x = execute(a[2]);
 			if (isbreak(x)) {
-				tempfree(vp, "");
-				return (true);
+				tempfree(vp);
+				return (True);
 			}
 			if (isnext(x) || isexit(x) || isret(x)) {
-				tempfree(vp, "");
+				tempfree(vp);
 				return (x);
 			}
-			tempfree(x, "");
+			tempfree(x);
 		}
 	}
-	return (true);
+	return (True);
 }
 
+/*
+ * builtin functions. a[0] is type, a[1] is arg list
+ */
 /*ARGSUSED*/
 Cell *
 bltin(Node **a, int n)
 {
-	register Cell *x, *y;
+	Cell *x, *y;
 	Awkfloat u;
-	register int t;
+	int t;
+	Awkfloat tmp;
 	uchar *p, *buf;
 	Node *nextarg;
+	FILE *fp;
 
-	t = (int)a[0];
+	t = ptoi(a[0]);
 	x = execute(a[1]);
 	nextarg = a[1]->nnext;
 	switch (t) {
 	case FLENGTH:
-		u = (Awkfloat)strlen((char *)getsval(x)); break;
+		if (isarr(x)) {
+			/* GROT.  should be function */
+			/* LINTED align */
+			u = (Awkfloat)((Array *)x->sval)->nelem;
+		} else {
+			u = (Awkfloat)strlen((char *)getsval(x));
+		}
+		break;
 	case FLOG:
 		u = errcheck(log(getfval(x)), "log"); break;
 	case FINT:
@@ -1509,13 +1686,12 @@
 		u = cos(getfval(x)); break;
 	case FATAN:
 		if (nextarg == 0) {
-			ERROR "atan2 requires two arguments; returning 1.0"
-			    WARNING;
+			WARNING("atan2 requires two arguments; returning 1.0");
 			u = 1.0;
 		} else {
 			y = execute(a[1]->nnext);
 			u = atan2(getfval(x), getfval(y));
-			tempfree(y, "");
+			tempfree(y);
 			nextarg = nextarg->nnext;
 		}
 		break;
@@ -1526,14 +1702,18 @@
 		u = (Awkfloat)system((char *)getsval(x)) / 256;
 		break;
 	case FRAND:
-		u = (Awkfloat)(rand() % 32767) / 32767.0;
+		/* in principle, rand() returns something in 0..RAND_MAX */
+		u = (Awkfloat)(rand() % RAND_MAX) / RAND_MAX;
 		break;
 	case FSRAND:
-		if (x->tval & REC)	/* no argument provided */
+		if (isrec(x))	/* no argument provided */
 			u = time((time_t *)0);
 		else
 			u = getfval(x);
-		srand((int)u); u = (int)u;
+		tmp = u;
+		srand((unsigned int)u);
+		u = srand_seed;
+		srand_seed = tmp;
 		break;
 	case FTOUPPER:
 	case FTOLOWER:
@@ -1547,20 +1727,30 @@
 				if (isupper(*p))
 					*p = tolower(*p);
 		}
-		tempfree(x, "");
-		x = gettemp("");
+		tempfree(x);
+		x = gettemp();
 		(void) setsval(x, buf);
 		free(buf);
 		return (x);
+	case FFLUSH:
+		if (isrec(x) || strlen((char *)getsval(x)) == 0) {
+			/* fflush() or fflush("") -> all */
+			flush_all();
+			u = 0;
+		} else if ((fp = openfile(FFLUSH, getsval(x))) == NULL)
+			u = EOF;
+		else
+			u = fflush(fp);
+		break;
 	default:	/* can't happen */
-		ERROR "illegal function type %d", t FATAL;
+		FATAL("illegal function type %d", t);
 		break;
 	}
-	tempfree(x, "");
-	x = gettemp("");
+	tempfree(x);
+	x = gettemp();
 	(void) setfval(x, u);
 	if (nextarg != 0) {
-		ERROR "warning: function has too many arguments" WARNING;
+		WARNING("warning: function has too many arguments");
 		for (; nextarg; nextarg = nextarg->nnext)
 			(void) execute(nextarg);
 	}
@@ -1569,20 +1759,20 @@
 
 /*ARGSUSED*/
 Cell *
-print(Node **a, int n)
+printstat(Node **a, int n)		/* print a[0] */
 {
-	register Node *x;
-	register Cell *y;
+	Node *x;
+	Cell *y;
 	FILE *fp;
 
-	if (a[1] == 0)
+	if (a[1] == 0)	/* a[1] is redirection operator, a[2] is file */
 		fp = stdout;
 	else
-		fp = redirect((int)a[1], a[2]);
+		fp = redirect(ptoi(a[1]), a[2]);
 	for (x = a[0]; x != NULL; x = x->nnext) {
 		y = execute(x);
 		(void) fputs((char *)getsval(y), fp);
-		tempfree(y, "");
+		tempfree(y);
 		if (x->nnext == NULL)
 			(void) fputs((char *)*ORS, fp);
 		else
@@ -1590,7 +1780,9 @@
 	}
 	if (a[1] != 0)
 		(void) fflush(fp);
-	return (true);
+	if (ferror(fp))
+		FATAL("write error on %s", filename(fp));
+	return (True);
 }
 
 /*ARGSUSED*/
@@ -1600,14 +1792,8 @@
 	return (0);
 }
 
-struct {
-	FILE	*fp;
-	uchar	*fname;
-	int	mode;	/* '|', 'a', 'w' */
-} files[FOPEN_MAX];
-
 static FILE *
-redirect(int a, Node *b)
+redirect(int a, Node *b)	/* set up all i/o redirections */
 {
 	FILE *fp;
 	Cell *x;
@@ -1617,34 +1803,74 @@
 	fname = getsval(x);
 	fp = openfile(a, fname);
 	if (fp == NULL)
-		ERROR "can't open file %s", fname FATAL;
-	tempfree(x, "");
+		FATAL("can't open file %s", fname);
+	tempfree(x);
 	return (fp);
 }
 
+struct files {
+	FILE	*fp;
+	const uchar	*fname;
+	int	mode;	/* '|', 'a', 'w' => LE/LT, GT */
+} *files;
+
+int nfiles;
+
+static void
+stdinit(void)	/* in case stdin, etc., are not constants */
+{
+	nfiles = FOPEN_MAX;
+	files = calloc(nfiles, sizeof (*files));
+	if (files == NULL)
+		FATAL("can't allocate file memory for %u files", nfiles);
+	files[0].fp = stdin;
+	files[0].fname = (uchar *)"/dev/stdin";
+	files[0].mode = LT;
+	files[1].fp = stdout;
+	files[1].fname = (uchar *)"/dev/stdout";
+	files[1].mode = GT;
+	files[2].fp = stderr;
+	files[2].fname = (uchar *)"/dev/stderr";
+	files[2].mode = GT;
+}
+
 static FILE *
-openfile(int a, uchar *s)
+openfile(int a, const uchar *us)
 {
-	register int i, m;
-	register FILE *fp;
+	const uchar *s = us;
+	int i, m;
+	FILE *fp = 0;
 
 	if (*s == '\0')
-		ERROR "null file name in print or getline" FATAL;
-	for (i = 0; i < FOPEN_MAX; i++) {
+		FATAL("null file name in print or getline");
+	for (i = 0; i < nfiles; i++) {
 		if (files[i].fname &&
-		    strcmp((char *)s, (char *)files[i].fname) == 0) {
+		    (strcmp((char *)s, (char *)files[i].fname) == 0)) {
 			if (a == files[i].mode ||
-			    a == APPEND && files[i].mode == GT) {
+			    (a == APPEND && files[i].mode == GT)) {
 				return (files[i].fp);
 			}
+			if (a == FFLUSH)
+				return (files[i].fp);
 		}
 	}
-	for (i = 0; i < FOPEN_MAX; i++) {
+	if (a == FFLUSH)	/* didn't find it, so don't create it! */
+		return (NULL);
+
+	for (i = 0; i < nfiles; i++) {
 		if (files[i].fp == 0)
 			break;
 	}
-	if (i >= FOPEN_MAX)
-		ERROR "%s makes too many open files", s FATAL;
+	if (i >= nfiles) {
+		struct files *nf;
+		int nnf = nfiles + FOPEN_MAX;
+		nf = realloc(files, nnf * sizeof (*nf));
+		if (nf == NULL)
+			FATAL("cannot grow files for %s and %d files", s, nnf);
+		(void) memset(&nf[nfiles], 0, FOPEN_MAX * sizeof (*nf));
+		nfiles = nnf;
+		files = nf;
+	}
 	(void) fflush(stdout);	/* force a semblance of order */
 	m = a;
 	if (a == GT) {
@@ -1660,7 +1886,7 @@
 		fp = strcmp((char *)s, "-") == 0 ?
 		    stdin : fopen((char *)s, "r");	/* "-" is stdin */
 	} else	/* can't happen */
-		ERROR "illegal redirection" FATAL;
+		FATAL("illegal redirection %d", a);
 	if (fp != NULL) {
 		files[i].fname = tostring(s);
 		files[i].fp = fp;
@@ -1669,38 +1895,55 @@
 	return (fp);
 }
 
+static const char *
+filename(FILE *fp)
+{
+	int i;
+
+	for (i = 0; i < nfiles; i++) {
+		if (fp == files[i].fp)
+			return ((char *)files[i].fname);
+	}
+
+	return ("???");
+}
+
 /*ARGSUSED*/
 Cell *
 closefile(Node **a, int n)
 {
-	register Cell *x;
+	Cell *x;
 	int i, stat;
 
 	x = execute(a[0]);
 	(void) getsval(x);
-	for (i = 0; i < FOPEN_MAX; i++) {
+	stat = -1;
+	for (i = 0; i < nfiles; i++) {
 		if (files[i].fname &&
 		    strcmp((char *)x->sval, (char *)files[i].fname) == 0) {
 			if (ferror(files[i].fp)) {
-				ERROR "i/o error occurred on %s",
-				    files[i].fname WARNING;
+				WARNING("i/o error occurred on %s",
+				    files[i].fname);
 			}
 			if (files[i].mode == '|' || files[i].mode == LE)
 				stat = pclose(files[i].fp);
 			else
 				stat = fclose(files[i].fp);
 			if (stat == EOF) {
-				ERROR "i/o error occurred closing %s",
-				    files[i].fname WARNING;
+				WARNING("i/o error occurred closing %s",
+				    files[i].fname);
 			}
-			xfree(files[i].fname);
+			if (i > 2)	/* don't do /dev/std... */
+				xfree(files[i].fname);
 			/* watch out for ref thru this */
 			files[i].fname = NULL;
 			files[i].fp = NULL;
 		}
 	}
-	tempfree(x, "close");
-	return (true);
+	tempfree(x);
+	x = gettemp();
+	(void) setfval(x, (Awkfloat)stat);
+	return (x);
 }
 
 static void
